#TEMPLATE(ProcessExtension,'Process extensions'),FAMILY('CW20'),FAMILY('ABC')
#!
#EXTENSION(ProcessAnimateIcons,'Progress window extension template')
#!--------------------------------------------------------------------------------------
#! Extension template for process procedures.  Animates icons instead of displaying
#! a progress bar.  
#!
#! Written:   March 8th, 1998 by Arnor Baldvinsson, Denmark
#!
#! Modified:  June 21st, 1998.  Added window caption and user string configuration
#!
#! Modified:  July 19th, 1998.  New progress bar instead of the standard progress.
#!                              Percent value controlled colouring of progressbar.
#!                              Hide the progress window.
#!                              Post event to another thread.
#!
#!--------------------------------------------------------------------------------------
#!                                        Main code section
#!--------------------------------------------------------------------------------------
#SHEET
  #TAB('Progress window')
    #PROMPT('Hide progress window',CHECK),%ProgressWindowHide,AT(90)
    #ENABLE(%ProgressWindowHide)
      #PROMPT('Post event when updating',CHECK),%ProgressWindowPostEvent,AT(90)
      #ENABLE(%ProgressWindowPostEvent)
        #PROMPT('Thread for event',FIELD),%ProgressWindowThreadToPostTo,AT(90)
        #PROMPT('Event to post',@s30),%ProgressWindowEventToPost,AT(90)
      #ENDENABLE
      #ENDENABLE
    #PROMPT('Window caption:',@s50),%ProgressWindowCaption,DEFAULT('''Progress...'''),AT(90)
    #PROMPT('Text to display:',@s50),%ProgressWindowText,DEFAULT(''),AT(90)
    #DISPLAY('')
    #DISPLAY('Remember to use quotation marks around texts in the')
    #DISPLAY('fields above.  You can use fields as well if you want to.')
    #DISPLAY('')
    #ENABLE(%ProgressWindowCaption > '')
      #PROMPT('Update caption with animation',Check),%ProgressWindowCaptionUpdate,DEFAULT(%TRUE),AT(10)
    #ENDENABLE
    #ENABLE(%ProgressWindowText > '')
      #PROMPT('Update text with animation',Check),%ProgressWindowTextUpdate,DEFAULT(%TRUE),AT(10)
      #PROMPT('Text field alignment:',Drop('Left|Center|Right')),%ProgressWindowTextAlign,AT(90)
      #PROMPT('Font name:',@s40),%PRogressWindowTextFont,DEFAULT('MS Sans Serif'),AT(90)
      #PROMPT('Font size:',Drop('6|8|10|12|14')),%ProgressWindowTextFontSize,Default(8),AT(90)
      #PROMPT('Distance from border: ',@n3),%ProgressWindowTextXpos,Default(5),AT(90)
    #ENDENABLE
    #PROMPT('Progress appearence',OPTION),%ProgressWindowAppearence
    #PROMPT('Animate icons',RADIO)
    #PROMPT('Solid progress bar',RADIO)
  #ENDTAB
  #TAB('Animated icons')
    #ENABLE(%ProgressWindowAppearence='Animate icons')
      #DISPLAY('Number of records to process')
      #PROMPT('between animations:',@n3),%RecordsBetweenAnimations,DEFAULT(1),AT(90)
      #PROMPT('Link Icons in project',CHECK),%IconsLinkedInProject,AT(90)
      #BUTTON('Icons to animate'),MULTI(%IconsToAnimate,%IconToAnimate),AT(90)
        #PROMPT('Icon file',OpenDialog('Icon file','Icon files|*.ico')),%IconToAnimate
      #ENDBUTTON
    #ENDENABLE
  #ENDTAB
  #TAB('Solid progress bars')
    #ENABLE(%ProgressWindowAppearence='Solid progress bar')
      #PROMPT('Default bar colour',COLOR),%ProgressBarDefaultColor,DEFAULT('COLOR:Blue'),AT(90)
      #PROMPT('Progress bar height',@n2),%ProgressBarHeight,DEFAULT(10),AT(90)
      #PROMPT('Value controlled colour',CHECK),%ProgressBarControlColor,DEFAULT(%FALSE),AT(90)
      #ENABLE(%ProgressBarControlColor=%TRUE)
        #BUTTON('Percent range'),MULTI(%ProgressPercentRanges,%ProgressPercentRange),AT(90)
          #PROMPT('Percent 0 - ',@n3),%ProgressPercentRange
          #PROMPT('Colour for range',COLOR),%ProgressPercentRangeColor,DEFAULT('COLOR:Blue')
        #ENDBUTTON
      #ENDENABLE
    #ENDENABLE
  #ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------------------------
#!                                          Project setup
#!--------------------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#IF(%IconsLinkedInProject)
  #FOR(%IconsToAnimate)
    #PROJECT (%IconToAnimate)
  #ENDFOR
#ENDIF
#ENDAT
#!--------------------------------------------------------------------------------------
#!                                     Local data declaration
#!--------------------------------------------------------------------------------------
#AT(%DeclarationSection)
Loc:LastPercent          BYTE
#IF(%ProgressWindowAppearence='Animate icons')
ProgressImageControl     LONG
Loc:IconCounter          LONG
Loc:RecordCounter        LONG
#ENDIF
#IF(%ProgressWindowAppearence='Solid progress bar')
#DECLARE(%NumberOfVarColors,LONG)
ProgressBar1Control      LONG
ProgressBar2Control      LONG
 #IF(%ProgressBarControlColor)
#SET(%NumberOfVarColors,0)
#FOR(%ProgressPercentRanges)
  #SET(%NumberOfVarColors,%NumberOfVarColors+1)
#ENDFOR
Loc:ColorSets            BYTE,DIM(%NumberOfVarColors) ! Percents for set
Loc:SetColor             LONG,DIM(%NumberOfVarColors) ! Colour for Set
Loc:ColorSet             BYTE(%NumberOfVarColors)     ! Number of sets
Loc:BarColor             LONG                         ! Color of the bar
 #ENDIF
#ENDIF
#ENDAT
#!--------------------------------------------------------------------------------------
#!                                    After opening the window
#!--------------------------------------------------------------------------------------
#AT(%AfterOpeningWindow)
#IF(%ProgressWindowHide)
 ProgressWindow{Prop:Hide} = True
 ProgressWindow{Prop:Cursor} = CURSOR:Wait
#! ENDIF
#! ENDAT
#! AT(%BeforeKeySet)
#! IF(%ProgressWindowHide)
! ProgressWindow{Prop:Hide} = True
#ELSE
 #IF(%ProgressWindowAppearence='Animate icons')
#!-------------------------------------------------------------------
#!                          * Animated icons *
#!-------------------------------------------------------------------
  #DECLARE(%FirstIcon,STRING)
 ?Progress:Thermometer {Prop:Hide}  = True
 ?Progress:PctText     {Prop:Hide}  = True
 ProgressImageControl               = LastField() + 1
 Create(ProgressImageControl,Create:Image)
 ProgressImageControl {Prop:Width}  = 20
 ProgressImageControl {Prop:Height} = 20
 ProgressImageControl {Prop:Xpos}   = (ProgressWindow{Prop:Width} / 2) - (ProgressImageControl{Prop:Width}/2)
 ProgressImageControl {Prop:Ypos}   = ?Progress:UserString{Prop:Ypos} + ?Progress:UserString{Prop:Height} + 1
  #FOR(%IconsToAnimate)
   #SET(%FirstIcon,%IconToAnimate)
   #BREAK
  #ENDFOR

  #IF(%IconsLinkedInProject)
 ProgressImageControl {Prop:Text}   = '~%FirstIcon' 
  #ELSE
 ProgressImageControl {Prop:Text}   = '%FirstIcon' 
  #ENDIF
 ProgressImageControl {Prop:Hide}   = False
 Display()
  #ENDIF
#!-------------------------------------------------------------------
#!                    * Solid progress bars *
#!-------------------------------------------------------------------
  #IF(%ProgressWindowAppearence='Solid progress bar')
 ?Progress:Thermometer {Prop:Hide}  = True
 ProgressBar1Control = LastField() + 1
 ProgressBar2Control = LastField() + 2
 Create(ProgressBar1Control,Create:Panel)    ! Progressbar outline
 Create(ProgressBar2Control,Create:Box)      ! Progressbar
 ProgressBar1Control{Prop:Xpos}      = ?Progress:Thermometer{Prop:Xpos}
 ProgressBar1Control{Prop:Ypos}      = ?Progress:Thermometer{Prop:Ypos}
 ProgressBar1Control{Prop:Width}     = ?Progress:Thermometer{Prop:Width}
 ProgressBar1Control{Prop:Height}    = %ProgressBarHeight
 ProgressBar1Control{Prop:Fill}      = Color:None
 ProgressBar1Control{Prop:BevelInner}= -1
 ProgressBar1Control{Prop:BevelOuter}= -1

 ProgressBar2Control{Prop:Xpos}      = ?Progress:Thermometer{Prop:Xpos} + 1
 ProgressBar2Control{Prop:Ypos}      = ?Progress:Thermometer{Prop:Ypos} + 1
 ProgressBar2Control{Prop:Width}     = 0
 ProgressBar2Control{Prop:Height}    = %ProgressBarHeight -2
 ProgressBar2Control{Prop:FillColor} = Color:None
 ProgressBar2Control{Prop:Fill}      = %ProgressBarDefaultColor
 Destroy(?Progress:Thermometer)              ! Destroy it, no longer needed.

 ProgressBar1Control{Prop:Hide}      = False 
 ProgressBar2Control{Prop:Hide}      = False 
 Loc:LastPercent                     = 0
  #IF(%ProgressBarControlColor)
   #SET(%NumberOfVarColors,0)
   #FOR(%ProgressPercentRanges)
   #SET(%NumberOfVarColors,%NumberOfVarColors+1)
 Loc:ColorSets[%NumberOfVarColors] = %ProgressPercentRange
 Loc:SetColor[%NumberOfVarColors]  = %ProgressPercentRangeColor
   #ENDFOR
 Loc:ColorSet = %NumberOfVarColors
   #ENDIF
  #ENDIF
#!-------------------------------------------------------------------
#!                  * Standard window handling *
#!-------------------------------------------------------------------
  #IF(%ProgressWindowCaption)
  ProgressWindow{Prop:Text} = Clip(%ProgressWindowCaption)
  #ELSE
  ProgressWindow{Prop:Text} = 'Processing...'
  #ENDIF
  #IF(%ProgressWindowText)
  ?Progress:UserString{Prop:Text} = Clip(%ProgressWindowText)
   #CASE(%ProgressWindowTextAlign)
   #OF('Left')
    ?Progress:UserString{Prop:Left} = True
   #OF('Center')
    ?Progress:UserString{Prop:Center} = True
   #OF('Right')
    ?Progress:UserString{Prop:Right} = True
   #ENDCASE
   #IF(%PRogressWindowTextFont)
    ?Progress:UserString{Prop:FontName} = '%PRogressWindowTextFont'
   #ENDIF
   #IF(%ProgressWindowTextFontSize)
    ?Progress:UserString{Prop:FontSize} = %PRogressWindowTextFontSize
   #ENDIF
   #IF(%ProgressWindowTextXpos)
    ?Progress:UserString{Prop:Xpos} = %ProgressWindowTextXpos
    ?Progress:UserString{Prop:Width} = ProgressWindow{Prop:Width} - %ProgressWindowTextXpos
   #ENDIF
  #ENDIF
 #ENDIF
#ENDAT
#!--------------------------------------------------------------------------------------
#!                                  Activity for each record
#!--------------------------------------------------------------------------------------
#AT(%BeforeSubsequentRead)
#IF(%ProgressWindowHide)                              #! Window is hidden
  #IF(%ProgressWindowPostEvent)                       #! Post events
    #IF(%ProgressWindowThreadToPostTo > '')           #! Thread defined
      #IF(%ProgressWindowEventToPost > '')            #! Event defined
If PercentProgress <> Loc:LastPercent
  Post(%ProgressWindowEventToPost,,%ProgressWindowThreadToPostTo)
  Loc:LastPercent = PercentProgress
End
      #ENDIF
    #ENDIF
  #ENDIF
#ELSE                                                 #! Window not hidden
 #IF(%ProgressWindowAppearence='Animate icons')
Loc:RecordCounter += 1
If Loc:RecordCounter = %RecordsBetweenAnimations
  Do AnimateIcons
  Loc:RecordCounter = 0
End
 #ENDIF
 #IF(%ProgressWindowAppearence='Solid progress bar')
  #IF(%ProgressBarControlColor)
Loop X# = 1 To Loc:ColorSet
  If X# = 1
    If PercentProgress < Loc:ColorSets[1]
      Loc:BarColor = Loc:SetColor[1]
      Break
    End
  Else
    If Inrange(PercentProgress,0,Loc:ColorSets[X#]) And PercentProgress > Loc:ColorSets[X#-1]
      Loc:BarColor = Loc:SetColor[X#]
      Break
    End
  End
End 
If ProgressBar2Control{Prop:Fill} <> Loc:BarColor  ! Only set if necessary
  ProgressBar2Control{Prop:Fill} = Loc:BarColor
End  
  #ENDIF
If PercentProgress <> Loc:LastPercent
  ProgressBar2Control{Prop:Width}     = (ProgressBar1Control{Prop:Width}-2) * (PercentProgress/100)
  Do UpdateProgressTexts
  Loc:LastPercent = PercentProgress
End
 #ENDIF
#ENDIF 
#ENDAT
#!--------------------------------------------------------------------------------------
#!                                     Procedure routines
#!--------------------------------------------------------------------------------------
#AT(%ProcedureRoutines)
#IF(%ProgressWindowAppearence='Solid progress bar')
UpdateProgressTexts    ROUTINE
 #IF(%ProgressWindowTextUpdate)
  #IF(%ProgressWindowText)
  ?Progress:UserString{Prop:Text} = Clip(%ProgressWindowText)
  Display(?Progress:UserString)
  #ENDIF
 #ENDIF
 #IF(%ProgressWindowCaptionUpdate)
  #IF(%ProgressWindowCaption)
  ProgressWindow{Prop:Text} = Clip(%ProgressWindowCaption)
  #ENDIF
 #ENDIF
#ENDIF

#IF(%ProgressWindowAppearence='Animate icons')
 #DECLARE(%IconCounter,LONG)
AnimateIcons    ROUTINE
 #SET(%IconCounter,0)
 #FOR(%IconsToAnimate)
  #SET(%IconCounter,%IconCounter +1)
 #ENDFOR
  Loc:IconCounter += 1
  If Loc:IconCounter > %IconCounter
    Loc:IconCounter = 1
  End
  Case Loc:IconCounter
 #SET(%IconCounter,0)  
 #FOR(%IconsToAnimate)
  #SET(%IconCounter,%IconCounter+1)  
  Of %IconCounter
 #IF(%IconsLinkedInProject)  
    ProgressImageControl{Prop:Text} = '~%IconToAnimate'
 #ELSE
    ProgressImageControl{Prop:Text} = '%IconToAnimate'
 #ENDIF
 #ENDFOR
  End
 #IF(%ProgressWindowTextUpdate)
  #IF(%ProgressWindowText)
  ?Progress:UserString{Prop:Text} = Clip(%ProgressWindowText)
  Display(?Progress:UserString)
  #ENDIF
 #ENDIF
 #IF(%ProgressWindowCaptionUpdate)
  #IF(%ProgressWindowCaption)
  ProgressWindow{Prop:Text} = Clip(%ProgressWindowCaption)
  #ENDIF
 #ENDIF
#ENDIF
#ENDAT

